<template>
  <div>
    <v-container class="inside">
      <v-row>
        <v-col md="1">
          <hr class="linea" style="left:20px;height:100%;" />
          <hr class="linea" style="left:30px;height:90%;" />
          <hr class="linea" style="left:40px;height:70%;" />
          <hr class="linea" style="left:20px;height:100%;" />
          <hr class="linea" style="left:30px;height:90%;" />
          <hr class="linea" style="left:40px;height:70%;" />
        </v-col>
        <v-col md="10">
          <img
            src="https://i.pinimg.com/474x/06/c0/06/06c0064630eb6b209f403e5cfec7237f--greeting-cards.jpg"
            class="logo"
          />
          <h1>Ceremonia de Graduación</h1>
          <h2 id="generacion">2016 - 2021</h2>

          <h2>Auditorio "Heber Soto"</h2>
          <br />
          <h5 class="programa">PASE DE LISTA TURNO MATUTINO</h5>
          <h2 id="date">{{dateMorning[0]}}</h2>
          <div class="alumno">
            <hr />

            <v-simple-table dense>
              <template v-slot:default>
                <thead>
                  <tr>
                    <th class="text-left">Name</th>
                    <th class="text-left">Career</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in morningItems" :key="item.idc">
                    <td>{{ item.name }}</td>
                    <td>{{ item.career[0] }}</td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>

            <hr />
          </div>

          <h5 class="programa">PASE DE LISTA TURNO VESPERTINO</h5>
          <h2 id="date">{{dateMorning[1]}}</h2>
          <div class="alumno">
            <hr />

            <v-simple-table dense>
              <template v-slot:default>
                <thead>
                  <tr>
                    <th class="text-left">Name</th>
                    <th class="text-left">Career</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item1 in afternoonItems" :key="item1.idc">
                    <td>{{ item1.name }}</td>
                    <td>{{ item1.career[0] }}</td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>

            <hr />
          </div>
        </v-col>
        <v-col md="1">
          <button onclick="print()">IMPRIMIR</button>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import firebase from "firebase";
export default {
  data() {
    return {
      morningItems: [],
      afternoonItems: [],
      dateMorning: []
    };
  },
  methods: {
    async get_career(id) {
      var db = firebase.firestore();
      var rt = [];
      try {
        const resp = await db
          .collection("careers")
          .doc(id)
          .get();
        rt.push(resp.data().name);
      } catch (error) {}
      return rt;
    }
  },
  created() {
    var db = firebase.firestore();
    // ********* CONSULTA PARA OBTENER A GRADUADOS PARA LISTARLOS ***************
    // Arrays con los id's de las carreras que se graduan en la mañana y en la tarde
    var careersMorning = [
      "CDVg1aIhaGYR4bxuWRUj",
      "8FQJ8J8aQpm1KMIoiJAv",
      "LU9ZlhJQgOnKzwC287Sw",
      "DKOVpU2GDuF5fGMGdCSb",
      "GAucYNOESXIH3WqfDfzL",
      "PZelh5COePfkwOvSTaOr",
      "ah4Vdvt2H7BVX9NVeOcP",
      "b22fd4h61Kj4EA7Zhi5v",
      "qFuJ9jjM7lxvwKbNiCH9",
      "tkknRbene9Bk52rRmSve",
      "ySAV93AHKWTbZpHyn6Nw",
      "zhZ7ZIUPyOaqG7Ym4DJK"
    ];
    var careersAfternoon = [
      "16TZvPIc5XpDAn5e4KwR",
      "DSPrPl1ueUoFVjKCmWuf",
      "Ds6jhOFwYnrfLFV5yvlq",
      "FlYRFl9nyrz0Kl1Mam22",
      "Ngbj4MwaFwL1VCr66uAL",
      "PZscEfGJlQBRpNcXDWgR",
      "bHLf9OgOC5xK7iH0YWUb",
      "bid9LWZgQCqa2wTIz3yb",
      "cXtYa46Sa8aFUsv5dopU",
      "pCRdulfljhuvrhA39MNF",
      "q1WNq0v2CI21S3R67JhZ",
      "zAU1JXhVu2RuZvFMOqjk"
    ];

    let morningReferences = [];
    let afternoonReferences = [];

    // Creación de referencias
    careersMorning.forEach(career => {
      const careerRef = db.collection("careers").doc(career);
      morningReferences.push(careerRef);
    });
    careersAfternoon.forEach(carreer => {
      const careerRef = db.collection("careers").doc(carreer);
      afternoonReferences.push(careerRef);
    });

    //Consultas a BD
    morningReferences.forEach(reference => {
      db.collection("requests")
        .where("career", "==", reference)
        .where("accepted", "==", 1)
        .get()
        .then(result => {
          result.forEach(async student => {
            var nameCareer = await this.get_career(student.data().career.id);
            var yeison = {
              name: student.data().name + " " + student.data().lastname,
              career: nameCareer,
              idc: student.id
            };
            //console.log(nameCareer);
            this.morningItems.push(yeison);
          });
        });
    });
    afternoonReferences.forEach(reference => {
      db.collection("requests")
        .where("career", "==", reference)
        .where("accepted", "==", 1)
        .get()
        .then(result => {
          result.forEach(async student => {
            var nameCareer = await this.get_career(student.data().career.id);
            var yeison = {
              name: student.data().name + " " + student.data().lastname,
              career: nameCareer,
              idc: student.id
            };
            this.afternoonItems.push(yeison);
            //console.log(student.data());
          });
        });
    });
    //event data
      db.collection("events")
        .get()
        .then(async result => {
          result.forEach(doc => {
            var months = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Ocubre", "Noviembre", "Diciembre"];
           // console.log(months[doc.data().date.toDate().getMonth()] + ' ' + doc.data().date.toDate().getDate() + ', ' + doc.data().date.toDate().getFullYear() + ' a las ' + doc.data().date.toDate().getHours() + ':' + doc.data().date.toDate().getMinutes() + '0 hrs');
            this.dateMorning.push(months[doc.data().date.toDate().getMonth()] + ' ' + doc.data().date.toDate().getDate() + ', ' + doc.data().date.toDate().getFullYear() + ' a las ' + doc.data().date.toDate().getHours() + ':' + doc.data().date.toDate().getMinutes() + '0 hrs')

          });
        });
  }
};
</script>

<style scoped>
.inside {
  background-color: white;
}
body {
  z-index: -10000;
  background-color: white !important;
  margin: 20px 60px;
  margin-left: 100px;
  width: calc(100% - 160px);
  box-sizing: border-box;
  text-align: center;
  font-family: "Roboto", sans-serif;
}
.logo {
  height: 140px;
}
h1 {
  color: #ae8d12;
  font-size: 2rem;
  text-align: center;
  font-weight: normal;
  margin: 0;
}
h2 {
  margin: 0;
  color: #030303;
  text-align: center;
  font-weight: normal;
}
h5 {
  font-weight: 300;
  color: #434343;
  font-size: 1.3rem;
  margin: 0;
  text-align: center;
}
hr {
  background-color: #c5c5c5;
  width: 90%;
  margin: 0 auto;
}
button {
  background-color: #cfc484;
  color: white;
  font-weight: bold;
  text-transform: capitalize;
  border-radius: 6px;
  padding: 8px 16px;
  border: none;
  cursor: pointer;
}
.linea {
  border: none;
  border-left: 2px solid #cfc484;
  display: block;
  position: absolute;
  top: 10px;
  left: 0;
  width: 2px;
  max-height: calc(100% - 10px);
}
.auditorio {
  display: flex;
  justify-content: center;
  align-items: center;
  margin: 16px 0;
}
.auditorio > * {
  margin: 0 10px;
}
.programa {
  color: #1a1a1a;
  font-weight: normal;
  font-size: 1.4rem;
  margin: 8px 0;
}
.evento {
  color: #686868;
  font-size: 1.2rem;
  font-weight: 400;
  margin: 4px 0;
}
.alumno {
  margin: 16px 0;
  margin-top: 100px;
}
.qr {
  display: block;
  margin: 30px auto;
}

@media only print {
  button {
    display: none;
  }
}
</style>
